#include <stdio.h>

#ifndef EOL
 #define EOL '\n'
#endif
#define     BACK_SLASH  '\\'
#define   SINGLE_QUOTE  '\''
#define   DOUBLE_QUOTE  '\"'
#define       COMM_BEG  "/*"
#define       COMM_END  "*/"
#define       EOL_COMM  "//"

void work_single (char*,FILE*,FILE*);
void work_double (char*,FILE*,FILE*);
void work_eol (char*,FILE*);
void work_comm(char*,FILE*);

void main()  
{ 
 FILE *infil=stdin,*outfil=stdout;
 char buff[3]="  ";
 fread(buff,1,1,infil);
 while(fread(buff+1,1,1,infil))  
 { 
  if (*buff==SINGLE_QUOTE) work_single(buff,infil,outfil);
  if (*buff==DOUBLE_QUOTE) work_double(buff,infil,outfil);
  if (!strcmp(buff,EOL_COMM)) work_eol(buff,infil);
  if (!strcmp(buff,COMM_BEG)) work_comm(buff,infil);
  fwrite(buff,1,1,outfil);  
  *buff=*(buff+1);
 }
}

void work_double(char *buff,FILE *infil,FILE *outfil)
{ 
 short in_quotes=1; 
 fwrite(buff,1,1,outfil); 
 *buff=*(buff+1);
 while (fread(buff+1,1,1,infil) && in_quotes)  
 { 
  if (*buff==BACK_SLASH)  
  { 
   fwrite(buff,2,1,outfil); 
   fread(buff,2,1,infil);  
  }
  in_quotes=!(*buff==DOUBLE_QUOTE); 
  fwrite(buff,1,1,outfil); 
  *buff=*(buff+1);  
 }  
}

void work_single (char *buff,FILE *infil, FILE *outfil)
{ 
 short in_quotes=1; 
 fwrite(buff,1,1,outfil); 
 *buff=*(buff+1);
 while (fread(buff+1,1,1,infil) && in_quotes)  
 { 
  if (*buff==BACK_SLASH)  
  { 
   fwrite(buff,2,1,outfil); 
   fread(buff,2,1,infil);  
  }
  in_quotes=!(*buff==SINGLE_QUOTE); 
  fwrite(buff,1,1,outfil); 
  *buff=*(buff+1);  
 }  
}

void work_eol(char *buff,FILE* infil)
{
 short eol_c = 1;
 do  
 {
  *buff=*(buff+1);
  eol_c=*(buff)!=EOL;  
 }
 while(fread(buff+1,1,1,infil) && eol_c);  
}

void work_comm(char *buff,FILE* infil)
{
 short in_comment=1;
 fread(buff,1,1,infil); 
 while (fread(buff+1,1,1,infil) && in_comment)
 {
  if (!strcmp(buff,COMM_BEG)) in_comment++;  
  if (!strcmp(buff,COMM_END))  
  { 
   in_comment--; 
   fread(buff+1,1,1,infil);  
  }
  *buff=*(buff+1); 
 }
}
